<?php
///Класс постраничной навигации by Wapweb/////
##############################################
class pager {

	// Public methods&objects
	public $count;
	public $on_page;
	public $end;
	
	public function __construct($count,$on_page,$end) {
		$this->count = $count;
		$this->on_page = $on_page;
		$this->end = $end;
	}
	
	public function get_start() {
		return $this->start = $this->get_page() * $this->on_page - $this->on_page;
	}
	
	public function print_nav() {
		if ($this->get_total() > 1) {
			return '<center><nav aria-label="Page navigation"><ul class="pagination">'.$this->get_nav().'</ul></nav></center>';
		} else return false;
	}
	
	//Private methods&objects
	private $total;
	private $start;
	private $view;
	private $page;
	
	private function get_total() {
		return $this->total = intval(($this->count - 1) / ($this->on_page)) + 1;
	}
	
	private function get_page() {
		$this->page = isset($_GET['page']) && !empty($_GET['page']) ? intval($_GET['page']) : 1;
		if (empty($this->page) || $this->page < 0) $this->page = 1;
		if ($this->page > $this->get_total()) $this->page = $this->get_total();
		return $this->page;
	}
	
	private function get_nav() {
		if ($this->get_page() != 1) $this->view = '<li><a href= "'.$this->end. ($this->get_page() - 1) .'" aria-label="Previous"><span aria-hidden="true">&laquo;</span></a></li>';
		if (($this->get_page() - 4) > 0) $this->view.= '<li><a href="'.($this->end).'page-1">1</a></li>';
		if($this->get_page() - 2 > 0) $this->view.= '<li><a href= "'.$this->end. ($this->get_page() - 2) .'">'. ($this->get_page() - 2) .'</a></li>';
		if($this->get_page() - 1 > 0) $this->view.= '<li><a href= "'.$this->end. ($this->get_page() - 1) .'">'. ($this->get_page() - 1) .'</a></li>';
								$this->view.= '<li class="active"><a href="#">'.$this->get_page().' <span class="sr-only">(current)</span></a></li>';
		if($this->get_page() + 1 <= $this->get_total()) $this->view.= '<li><a href="'.$this->end.($this->get_page() + 1) .'">'. ($this->get_page() + 1) .'</a></li>';
		if($this->get_page() + 2 <= $this->get_total()) $this->view.= '<li><a href= "'.$this->end.($this->get_page() + 2) .'">'. ($this->get_page() + 2) .'</a></li>';
		if (($this->get_page() + 4) <= $this->get_total()) $this->view.= '<li><a href="'.($this->end).($this->get_total()).'">'.($this->get_total()).'</a></li>';
		if ($this->get_page() != $this->get_total()) $this->view.= '<li><a href="'.($this->end).($this->get_page() + 1) .'" aria-label="Next"><span aria-hidden="true">&raquo;</span></a></li>';
		return $this->view;
	}
	
}
?>